/*

Ampel "Merf"
 fr Auto Steht auf grn und fr Fugnger auf rot
 mensch drck
 Ampel geht fr Mensch auf grn und fr Auto fr 5 sec.
 und springt dann wieder auf normal status um

autoamp        grn    /       gelb    /       rot     /       rot, gelb       /       grn
fuamp         rot     /       rot     /       grn    /       rot             /       rot



        Ports auf ausgang schalten
        timer einstellen, interrups aktivieren, vergleichswert setzten
        Auto gruen schalten, Fusgaenger rot

 Do
        Wenn Taster nicht gedrueckt, back to Anfang
        Wenn Taster gedrueckt. warten.
        Wenn warten um, AUto gelb, fus rot
        warten
        auto rot, fus grn
        warten
        auto rot, gelb, fus rot
        warten
        auto grn, fus rot
        back to the future

 LOOP

LELFNOT
TCNT1 wird automatishc immer erhoehr
OCR1A hier kommt der wert zum vergleichen rein
fuer 2c warten, vergleichswert = 7200 bei einem prescaler von 1024



*/

#define 	F_CPU 3686400	// Taktfrequenz des myAVR-Boards
#include	<avr/io.h>		// AVR Register und Konstantendefinitionen
#include        <avr/interrupt.h>


#define AUTOROT   0
#define AUTOGELB  1
#define AUTOGRUEN 2
#define FUSROT    3
#define FUSGRUEN  4

#define TASTER    2

#define LEDOUT    PORTB
#define TASTERPORT PIND
#define TASTER1   PD2

volatile uint8_t timefertig = 0;

inline void startTimer()
{

        timefertig = 0;
        TCNT1 = 0;
        TCCR1B |= (1 << CS10) | (1 << CS12);
}

inline void stopTimer()
{

//         TCCR1B &= ~(1 << CS10) | (1 << CS11) | (1 << CS12);
        TCCR1B = 0;

}


SIGNAL(SIG_OUTPUT_COMPARE1A)
{

        timefertig = 1;
        stopTimer();
}


int main()
{
        DDRB = 0xFF;                       // PORTB = Ausgang
//           DDRD = 0x00;                       // PORTD = Eingang
        PORTD = 0xFF;                      // PORTD = PULL-UP


        // Timerprescaler auf 1024 setzten
//         TCCR1B |= (1 << CS10) | (1 << CS12);

        // Vergleichswert setzen; 7200 entsprechen 2 Sekunden
        OCR1A = 7200;
        // Output Compare Interrupt Register 1A Enable
        TIMSK |= (1 << OCIE1A) | (1 << TOIE1);

        // Interrupts einschalten
        sei();

        LEDOUT = (1 << AUTOGRUEN) | (1 << FUSROT);


        while(1)
        {
                //Wenn Taster nicht gedrueckt, back to Anfang
                if (PIND & (1 << PD2))
                        continue;

                // Wenn Taster gedrueckt. warten.
                startTimer();
                while(!timefertig) {};

                // Wenn warten um, AUto gelb, fus rot
                LEDOUT = (1 << AUTOGELB) | (1 << FUSROT);

                //warten
                startTimer();
                while(!timefertig) {};

                //auto rot, fus gruen
                LEDOUT = (1 << AUTOROT) | (1 << FUSGRUEN);

                // warten
                startTimer();
                while(!timefertig) {};

                //auto rot, gelb, fus rot
                LEDOUT = (1 << AUTOROT) | (1 << AUTOGELB) | (1 << FUSROT);

                // warten
                startTimer();
                while(!timefertig) {};

                // auto grn, fus rot
                LEDOUT = (1 << AUTOGRUEN) | (1 << FUSROT);


        }

}
